package com.application.GUI.PopUpWindows;

import com.application.GUI.Panes.LogoBar;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.PasswordField;
import javafx.scene.control.TextField;
import javafx.scene.layout.VBox;
import javafx.stage.Modality;
import javafx.stage.Stage;

import java.nio.charset.StandardCharsets;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.util.Arrays;

import static com.application.DB.Account_handler.getAccount;

public class LoginPopup {

    public static PasswordField PASSWORD_TEXT_FIELD = new PasswordField();

    public static void login(){

        Stage window = new Stage();
        window.initModality(Modality.APPLICATION_MODAL);
        window.setTitle("Login window");

        Label userNameLabel = new Label("Username:");
        Label passwordLabel = new Label("Password:");

        TextField userNameTextField = new TextField();

        Button closeButton = new Button("Close");
        Button loginButton = new Button("Login");

        closeButton.setOnAction(event -> window.close());
        loginButton.setOnAction(event -> {

            try {
                MessageDigest messageDigest = MessageDigest.getInstance("SHA-512");

                assert messageDigest != null;
                messageDigest.update(getPasswordTextField().getText().getBytes(StandardCharsets.UTF_8));

                byte[] hashedPassword = messageDigest.digest();

                StringBuilder hashedPasswordString = new StringBuilder();

                for (byte b: hashedPassword) {
                    hashedPasswordString.append(String.format("%02x",b));
                }

                getAccount(userNameTextField.getText(),hashedPasswordString.toString());

                if(!LogoBar.getLogin().getText().equals("Login")){
                    window.close();
                }

            } catch (Exception e) {
                e.printStackTrace();
            }




        });



        VBox layout = new VBox(10);
        layout.setAlignment(Pos.CENTER);
        layout.getChildren().addAll(userNameLabel, userNameTextField, passwordLabel, getPasswordTextField(), loginButton, closeButton);

        Scene scene = new Scene(layout, 500, 300);
        scene.getStylesheets().add(InputPopup.class.getResource("/com.application/CSS/styleSheet.css").toExternalForm());
        window.setScene(scene);
        window.showAndWait();
    }

    public static void adminPopup(){

        Stage window = new Stage();
        window.initModality(Modality.APPLICATION_MODAL);
        window.setTitle("Login window");


        VBox layout = new VBox(10);
        layout.setAlignment(Pos.CENTER);
        layout.getChildren().addAll();

        Scene scene = new Scene(layout, 500, 300);
        scene.getStylesheets().add(InputPopup.class.getResource("/com.application/CSS/styleSheet.css").toExternalForm());
        window.setScene(scene);
        window.showAndWait();
    }

    public static void userPopup(){

        Stage window = new Stage();
        window.initModality(Modality.APPLICATION_MODAL);
        window.setTitle("Login window");


        VBox layout = new VBox(10);
        layout.setAlignment(Pos.CENTER);
        layout.getChildren().addAll();

        Scene scene = new Scene(layout, 500, 300);
        scene.getStylesheets().add(InputPopup.class.getResource("/com.application/CSS/styleSheet.css").toExternalForm());
        window.setScene(scene);
        window.showAndWait();
    }

    public static PasswordField getPasswordTextField() {
        return PASSWORD_TEXT_FIELD;
    }
}
